Module SubMain
    Public Const SWP_NOACTIVATE = &H10
    Public Const SWP_NOZORDER = &H4
    Public Const SWP_SHOWWINDOW = &H40
    Public Const GWL_STYLE = -16
    Public Const WS_CHILD = &H40000000
    Public Const GWL_HWNDPARENT = -8
    Public Const HWND_TOP = 0

    Public Structure RECT
        Public left As Integer
        Public top As Integer
        Public right As Integer
        Public bottom As Integer
    End Structure

    Public Declare Function GetClientRect Lib "user32" ( _
        ByVal hwnd As Integer, _
        ByRef lpRect As RECT) As Integer

    Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" ( _
        ByVal hwnd As Integer, _
        ByVal nIndex As Integer) As Integer

    Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" ( _
        ByVal hwnd As Integer, _
        ByVal nIndex As Integer, _
        ByVal dwNewInteger As Integer) As Integer

    Public Declare Function SetWindowPos Lib "user32" ( _
        ByVal hwnd As Integer, _
        ByVal hWndInsertAfter As Integer, _
        ByVal x As Integer, _
        ByVal y As Integer, _
        ByVal cx As Integer, _
        ByVal cy As Integer, _
        ByVal wFlags As Integer) As Integer

    Public Declare Function SetParent Lib "user32" ( _
        ByVal hWndChild As Integer, _
        ByVal hWndNewParent As Integer) As Integer

    Public Enum ActionType
        actConfigure
        actPreview
        actRun
    End Enum

    Public m_Action As ActionType
    Public Sub Main(ByVal args As String())
        ' See what we should do.
        If args.Length = 0 Then
            m_Action = ActionType.actRun
        Else
            Select Case args(0).ToLower().Substring(0, 2)
                Case "/p"
                    m_Action = ActionType.actPreview
                Case "/c"
                    m_Action = ActionType.actConfigure
                Case "/s"
                    m_Action = ActionType.actRun
                Case Else
                    m_Action = ActionType.actRun
            End Select
        End If

        ' Do it.
        Select Case m_Action
            Case ActionType.actRun
                ' Normal screen saver.
                Dim canvas As New frmCanvas
                Application.Run(canvas)
            Case ActionType.actConfigure
                ' Configure.
                Dim dlg_config As New frmConfig
                Application.Run(dlg_config)
            Case ActionType.actPreview
                ' Preview.
                Dim canvas As New frmCanvas
                SetForm(canvas, args(1))
                Application.Run(canvas)
        End Select
    End Sub

    ' Reparent the form into the preview window.
    Private Sub SetForm(ByRef frm As Form, ByRef arg As String)
        Dim style As Integer
        Dim preview_hwnd As Integer = Integer.Parse(CType(arg, String))
        Dim r As New RECT

        ' Get the preview window's size.
        GetClientRect(preview_hwnd, r)

        With frm
            .WindowState = FormWindowState.Normal
            .FormBorderStyle = FormBorderStyle.None
            .Width = r.right
            .Height = r.bottom
        End With

        ' Add the WS_CHILD style to the form.
        style = GetWindowLong(frm.Handle.ToInt32, GWL_STYLE)
        style = style Or WS_CHILD
        SetWindowLong(frm.Handle.ToInt32, GWL_STYLE, style)

        ' Reparent the form into the preview window.
        SetParent(frm.Handle.ToInt32, preview_hwnd)

        ' Set the form's GWL_PARENT value to the preview window.
        SetWindowLong(frm.Handle.ToInt32, GWL_HWNDPARENT, preview_hwnd)

        ' Position the form in the preview window.
        SetWindowPos(frm.Handle.ToInt32, 0, r.left, 0, r.right, r.bottom, _
            SWP_NOACTIVATE Or SWP_NOZORDER Or SWP_SHOWWINDOW)
    End Sub
End Module
