Public Class frmCanvas
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents tmrMove As System.Windows.Forms.Timer
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.tmrMove = New System.Windows.Forms.Timer(Me.components)
        '
        'tmrMove
        '
        '
        'frmCanvas
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.Black
        Me.ClientSize = New System.Drawing.Size(292, 273)
        Me.ControlBox = False
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.None
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "frmCanvas"
        Me.ShowInTaskbar = False
        Me.Text = "Form1"
        Me.WindowState = System.Windows.Forms.FormWindowState.Maximized

    End Sub

#End Region

    Private m_Xmax As Integer
    Private m_Ymax As Integer

    ' (X, Y) is the ball's upper left corner.
    ' D is the ball's diameter.
    Private m_NumBalls As Long
    Private m_Color() As Color
    Private m_D() As Single
    Private m_X() As Single
    Private m_Y() As Single
    Private m_Vx() As Single
    Private m_Vy() As Single

    Private m_BufferBitmap As Bitmap
    Private m_BufferGraphics As Graphics
    Private m_Graphics As Graphics
    Private m_Random As New Random

    ' Hide the cursor, get ready, and enable
    ' the timer.
    Private Sub frmCanvas_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' See if we are running as a preview or screen saver.
        If m_Action = ActionType.actRun Then
            ' Screen saver. Hide the cursor.
            Cursor.Hide()
        Else
            ' Preview. Remove the KeyDown, MouseMove, and
            ' MouseDown event handlers.
            RemoveHandler Me.KeyDown, AddressOf frmCanvas_KeyDown
            RemoveHandler Me.MouseMove, AddressOf frmCanvas_MouseMove
            RemoveHandler Me.MouseDown, AddressOf frmCanvas_MouseDown
        End If

        ' Save the screen width and height.
        m_Xmax = Width
        m_Ymax = Height

        ' Get the number of balls.
        m_NumBalls = CLng(GetSetting("Bouncer", "Settings", "NumBalls", "20"))

        ' Create the balls.
        ReDim m_Color(m_NumBalls)
        ReDim m_D(m_NumBalls)
        ReDim m_X(m_NumBalls)
        ReDim m_Y(m_NumBalls)
        ReDim m_Vx(m_NumBalls)
        ReDim m_Vy(m_NumBalls)

        Const MAX_VEL As Single = 0.025
        Const MIN_D_FACTOR As Single = 0.025
        Const MAX_D_FACTOR As Single = 0.1
        For i As Integer = 0 To m_NumBalls - 1
            m_Color(i) = Color.FromArgb(&HFF000000 Or QBColor(m_Random.Next(1, 15)))
            m_D(i) = RandomSingle(m_Ymax * MIN_D_FACTOR, m_Ymax * MAX_D_FACTOR)
            m_X(i) = RandomSingle(1, m_Xmax - m_D(i))
            m_Y(i) = RandomSingle(1, m_Ymax - m_D(i))
            m_Vx(i) = RandomSingle(-m_Ymax * MAX_VEL, m_Ymax * MAX_VEL)
            m_Vy(i) = RandomSingle(-m_Ymax * MAX_VEL, m_Ymax * MAX_VEL)
        Next i

        ' Make a buffer Bitmap and Graphics.
        m_BufferBitmap = New Bitmap(m_Xmax, m_Ymax)
        m_BufferGraphics = Graphics.FromImage(m_BufferBitmap)

        ' Create a Graphics object for the form.
        m_Graphics = CreateGraphics()

        ' Enable the timer.
        tmrMove.Enabled = True
    End Sub

    ' Return a random Single between min_value and max_value.
    Private Function RandomSingle(ByVal min_value As Single, ByVal max_value As Single) As Single
        Return min_value + (max_value - min_value) * m_Random.NextDouble()
    End Function

    ' Move the balls.
    Private Sub tmrMove_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles tmrMove.Tick
        Dim i As Long

        ' Draw on the memory bitmap.
        m_BufferGraphics.Clear(System.Drawing.Color.Black)
        For i = 0 To m_NumBalls - 1
            ' Update the ball's X coordinate.
            m_X(i) += m_Vx(i)
            If m_X(i) < 1 Then
                m_X(i) = 1 - m_X(i)
                m_Vx(i) *= -1
            ElseIf m_X(i) > m_Xmax - m_D(i) Then
                m_X(i) = (m_Xmax - m_D(i)) - (m_X(i) - (m_Xmax - m_D(i)))
                m_Vx(i) *= -1
            End If

            ' Update the ball's Y coordinate.
            m_Y(i) += m_Vy(i)
            If m_Y(i) < 1 Then
                m_Y(i) = 1 - m_Y(i)
                m_Vy(i) *= -1
            ElseIf m_Y(i) > m_Ymax - m_D(i) Then
                m_Y(i) = (m_Ymax - m_D(i)) - (m_Y(i) - (m_Ymax - m_D(i)))
                m_Vy(i) *= -1
            End If

            ' Draw the ball.
            Dim the_brush As New SolidBrush(m_Color(i))
            m_BufferGraphics.FillEllipse(the_brush, _
                m_X(i), m_Y(i), m_D(i), m_D(i))
            Dim the_pen As New Pen(m_Color(i))
            m_BufferGraphics.DrawEllipse(the_pen, _
                m_X(i), m_Y(i), m_D(i), m_D(i))
            the_brush.Dispose()
            the_pen.Dispose()
        Next i

        ' Copy the image onto the screen.
        m_Graphics.DrawImage(m_BufferBitmap, 0, 0)
    End Sub

    ' Stop if the mouse moves.
    Private Sub frmCanvas_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseMove
        Static done_before As Boolean
        Static mouse_x As Long
        Static mouse_y As Long

        ' If this is the first time, 
        ' save the mouse position.
        If Not done_before Then
            done_before = True
            mouse_x = e.X
            mouse_y = e.Y
        Else
            ' See if the mouse has moved.
            If Math.Abs(e.X - mouse_x) > 10 Or _
               Math.Abs(e.Y - mouse_y) > 10 _
            Then
                ' Close the form.
                Me.Close()
            End If
        End If
    End Sub

    ' Stop if the mouse button is pressed.
    Private Sub frmCanvas_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        Me.Close()
    End Sub

    ' Stop if the user presses a key.
    Private Sub frmCanvas_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyDown
        Me.Close()
    End Sub
End Class
